package fr.sesamvitale.fusetuto.tp3;

import java.util.Date;

import javax.annotation.Resource;
import javax.xml.ws.Holder;
import javax.xml.ws.WebServiceContext;

import org.apache.log4j.Logger;

import fr.sesamvitale.ws.cxftutorial.sayhello.InputSayHello;
import fr.sesamvitale.ws.cxftutorial.sayhello.InputSayHelloHeader;
import fr.sesamvitale.ws.cxftutorial.sayhello.OutputSayHello;
import fr.sesamvitale.ws.cxftutorial.sayhello.OutputSayHelloHeader;
import fr.sesamvitale.ws.cxftutorial.sayhello.SayHelloI;

public class SayHelloServiceImpl implements SayHelloI {
	
	private static final Logger logger = Logger.getLogger(SayHelloServiceImpl.class);

	@Resource
	public WebServiceContext context;
	
	@Resource
	public void sayHello(InputSayHello parametersIn,
			InputSayHelloHeader headerIn, Holder<OutputSayHello> parametersOut,
			Holder<OutputSayHelloHeader> headerOut) {
		
		String timestamp = Long.toString((new Date()).getTime());
		headerOut.value = new OutputSayHelloHeader();
		headerOut.value.setDateMessage(timestamp);
		headerOut.value.setSayHelloType(headerIn.getSayHelloType());
		
		parametersOut.value = new OutputSayHello();
		
		String type = headerIn.getSayHelloType();
		
		if ("1".equals(type)) {
			parametersOut.value.setResult("Hello "+parametersIn.getSurName()+" world at : "  + parametersIn.getDate());
		} else {
			parametersOut.value.setResult("Hello my world at : "  + timestamp);
		}
		
		logger.info("end sayHello");
	}


}
